﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Hi Mike, This is not a working project...
        //  I do not have time to wire-up something that simulated db calls for data based on 
        //  the value selected in another combo...
        //  Below are the Events and methods straight from my 2008 project with IG v9.2 controls.
        //  The code is horrible, I know, but it works perfectly in production to keep all 4 combos
        //  current and driven off each selection, over and over again.

        //  The problem comes from porting the form to a Visual Studio 2010 project using IG 2011 controls.
        //  Stepping through the code in 2010 shows the row selected event firing for each drop down
        //  when that drop down's datasource is set to null or to actual data. Not only that, but the drop
        //  downs tend to revert back to their previously selected values, regardless of the data that 
        //  that is freshy bound to them!  I have never seen the likes of this before.

        //  When the app loads, the very first selection from c1 works. It is the subsequent selections
        //  starting from c2 that produce unexpected resluts.

        //  This is a tough one because many "new" things are in-play:
        //  1.) New version of Visual Studio
        //  2.) New version of IG controls
        //  3.) AMD processor vs. intel
        //  4.) Existing form with controls added to a new project
        //  5.) Potential bad coding implementation.

        //  I admit that number 5 may be the leading candidate...

        //  Lastly, stored procedure and drop down names were renamed, and irrelevant case statements were
        //  deleted.



        /// <summary>
        /// Main (static) driver drop down
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void c1_RowSelected(object sender, RowSelectedEventArgs e)
        {
            if (c1.Value != null)
            {
                ShowHideDropDowns();
            }
        }

        /// <summary>
        /// Method that handles the value selected from c1. I deleted the other cases as they are 
        /// not relevent. These drop downs are not show unless case "A" is selected.
        /// </summary>
        private void ShowHideDropDowns()
        {
            switch (this.c1.Text.ToUpper())
            {
                case "A":
                    LoadDropDown("c2", "mySQLStoredProcedure1", null);
                    this.c2.Visible = true;
                    this.c3.Visible = true;
                    this.c4.Visible = true;
                    this.c5.Visible = true;
                    break;
                case "B":
                    LoadDropDown("cmbSector1", "mySQLStoredProcedure3", null);

                    this.c2.Visible = false;
                    this.c3.Visible = false;
                    this.c4.Visible = false;
                    this.c5.Visible = false;
                    break;
                default:
                    break;
            }
        }


        /// <summary>
        /// Populate any of the drop downs. Irrelevent cases were deleted.
        /// </summary>
        /// <param name="dropdownName"></param>
        /// <param name="spName"></param>
        /// <param name="sqlparm"></param>
        private void LoadDropDown(string dropdownName, string spName, SqlParameter[] sqlparm)
        {
            DataSet ds = null;
            SqlParameter[] sqlParms = null;

            switch (dropdownName)
            {
                case "c2":
                    sqlParms = new SqlParameter[] { new SqlParameter("@AssetClass", this.c1.Text) };
                    ds = _mySQL.GetDataSet(_settings.myConnectionString, spName, "Data", sqlParms);

                    if (this.c2.DataSource != null)
                    {
                        this.c3.DataSource = null;
                        this.c4.DataSource = null;
                        this.c5.DataSource = null;
                    }

                    //always set this datasource
                    this.c2.DataSource = null;
                    this.c2.DataSource = ds;
                    this.c2.ValueMember = "ColumnName";
                    this.c2.DisplayMember = "Industry";

                    if (ds.Tables[0].Rows.Count == 1)
                        this.c2.PerformAction(UltraComboAction.FirstRow);

                    break;
                case "c3":
                    sqlParms = new SqlParameter[] { new SqlParameter("@AssetClass", this.c1.Text),
                            new SqlParameter("@Industry", this.c2.Text)};
                    ds = _mySQL.GetDataSet(_settings.myConnectionString, spName, "Data", sqlParms);

                    if (this.c3.DataSource != null)
                    {
                        this.c4.DataSource = null;
                        this.c5.DataSource = null;
                    }

                    this.c3.DataSource = null;
                    this.c3.DataSource = ds;
                    this.c3.ValueMember = "ColumnName";
                    this.c3.DisplayMember = "SectorBroad";

                    if (ds.Tables[0].Rows.Count == 1)
                        this.c3.PerformAction(UltraComboAction.FirstRow);

                    break;
                case "c4":
                    sqlParms = new SqlParameter[] { new SqlParameter("@AssetClass", this.c1.Text),
                            new SqlParameter("@Industry", this.c2.Text),
                            new SqlParameter("@SectorBroad", this.c3.Text)};
                    ds = _mySQL.GetDataSet(_settings.myConnectionString, spName, "Data", sqlParms);

                    if (this.c4.DataSource == null)
                        this.c5.DataSource = null;

                    this.c4.DataSource = null;
                    this.c4.DataSource = ds;
                    this.c4.ValueMember = "ColumnName";
                    this.c4.DisplayMember = "SectorNarrow";

                    if (ds.Tables[0].Rows.Count == 1)
                        this.c4.PerformAction(UltraComboAction.FirstRow);

                    break;
                case "c5":
                    sqlParms = new SqlParameter[] { new SqlParameter("@AssetClass", this.c1.Text),
                            new SqlParameter("@Industry", this.c2.Text),
                            new SqlParameter("@SectorBroad", this.c3.Text),
                            new SqlParameter("@SectorNarrow", this.c4.Text),};
                    ds = _mySQL.GetDataSet(_settings.myConnectionString, spName, "Data", sqlParms);

                    this.c5.DataSource = null;
                    this.c5.DataSource = ds;
                    this.c5.ValueMember = "ColumnName";
                    this.c5.DisplayMember = "Description";

                    if (ds.Tables[0].Rows.Count == 1)
                        this.c5.PerformAction(UltraComboAction.FirstRow);

                    break;
                default:
                    break;
            }
        }

        private void c2_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].ColHeadersVisible = false;
            e.Layout.Bands[0].Columns["ColumnName"].Hidden = true;
        }

        private void c2_RowSelected(object sender, RowSelectedEventArgs e)
        {
            LoadDropDown("c3", "SQLStoredProcedure2", null);
            this.c3.Enabled = true;
        }

        private void c3_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].ColHeadersVisible = false;
            e.Layout.Bands[0].Columns["ColumnName"].Hidden = true;
        }

        private void c3_RowSelected(object sender, RowSelectedEventArgs e)
        {
            LoadDropDown("c4", "SQLStoredProcedure2", null);
            this.c4.Enabled = true;
        }

        private void c4_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].ColHeadersVisible = false;
            e.Layout.Bands[0].Columns["ColumnName"].Hidden = true;
        }

       private void c4_RowSelected(object sender, RowSelectedEventArgs e)
        {
            LoadDropDown("c5", "SQLStoredProcedure2", null);
            this.c5.Enabled = true;
        }

        private void c5_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].ColHeadersVisible = false;
            e.Layout.Bands[0].Columns["ColumnName"].Hidden = true;
        }

     }
}
